
#ifdef __KERNEL__
#include <linux/config.h>
#include <linux/string.h>
#else
#include "zbootcfg.h"
#include "uart.h"
#include "util.h"
#endif

#include "sha1sum.h"

#if defined(CONFIG_XENV_SUPPORT) || defined(CONFIG_TANGO2_XENV)

// #include "xos.h"

#define XENV_RDONLY

#ifndef __KERNEL__
typedef unsigned int RMuint32;
typedef unsigned short RMuint16;
typedef unsigned char RMuint8;
typedef char RMascii;
typedef int RMstatus;
#endif

/*
  append a single "1" bit to message
  append "0" bits until message length ~ 448 ~ -64 (mod 512)
  append length of message, in bits as 64-bit big-endian integer to message

  Below, size and left are expressed in bytes. Implementation is compact but endian-dependent
*/

void full_sha1(RMuint32 digest[5],const RMuint8 *src,RMuint32 size,RMuint32 fromISP)
{
#if 0
	if (fromISP) sink(); // unsupported
#else
	if (fromISP) return; // unsupported
#endif

	sha1sum(src, size, digest);
}
#endif /* CONFIG_XENV_SUPPORT */

