
/*****************************************
 Copyright © 2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   pci_fixups.c
  @brief  

  PCI support (fixups) for Tango2.

  @author YH Lin
  @date   2005-01-20
*/

#include <linux/types.h>
#include <linux/pci.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/pci_ids.h>


#include <asm/tango2/hardware.h>

#if defined(CONFIG_TANGO2_SIG_BLOCK) || defined(CONFIG_TANGO2_XENV)
extern int tango2_pcidev_irq_map(const int pci_idsel, const int int_num);
#endif

extern unsigned short get_gt_devid(void);

void __init pcibios_fixup_resources(struct pci_dev *dev)
{
}

void __init pcibios_fixup(void)
{
}

void __init pcibios_fixup_irqs(void)
{
	struct pci_dev *dev;

	pci_for_each_dev(dev) {
		if (dev->bus->number != 0)
			return;
		else {
#if defined(CONFIG_TANGO2_SIG_BLOCK) || defined(CONFIG_TANGO2_XENV)
			unsigned int slot = PCI_SLOT(dev->devfn);
			unsigned char irqpin;

			pci_read_config_byte(dev, PCI_INTERRUPT_PIN, &irqpin);
			if (irqpin) { /* This device is using interrupt */
				dev->irq = tango2_pcidev_irq_map(slot, irqpin - 1);
				pci_write_config_byte(dev, PCI_INTERRUPT_LINE, dev->irq);
			}
#else
			/* for generic */
			dev->irq = IRQ_PCI;
			pci_write_config_byte(dev, PCI_INTERRUPT_LINE, dev->irq);
#endif
		}
	}
}

unsigned int pcibios_assign_all_busses(void)
{
	return 0;
}

