// derived from hp-lj
	
#include <asm/asm.h>

#include <asm/mipsregs.h>
#include <asm/regdef.h>
#include <asm/stackframe.h>
#include <asm/current.h>
#include <asm/offset.h>
#include <asm/cachectl.h>
#include <asm/fpregdef.h>
#include <asm/page.h>
#include <asm/pgtable.h>
#include <asm/processor.h>
#include <asm/tango2/tango2.h>

	.text
	.set    mips1
	.set    reorder
	.set    macro
	.set    noat
	.align	5

# MIPS has 16 exception vectors numbered 0 to 15
# vector number 0 is for interrupts and the others are for various exceptions
# The following code is installed as the handler for exception 0
# There are 8 possible interrupts that can cause this exception.
# The cause register indicates which are pending
# The status register indicates which are enabled
# This code segment basically will decipher which interrup occurred (7 downto 0)
# and pass an integer indicating which was the highest priority pending interrupt
# to the do_IRQ routine.

NESTED(tango2IRQ, PT_SIZE, sp)
	SAVE_ALL
	CLI				# Important: mark KERNEL mode !
	/*
	 * Get pending interrupts
	 */

	mfc0	t0,CP0_CAUSE		# get pending interrupts
	mfc0	t1,CP0_STATUS		# get enabled interrupts
	and	t0,t1			# isolate allowed ones
	andi	t0,0xff00		# isolate pending bits
	sll	t0,16			# shift the pending bits down
	beqz	t0,3f			# no pending intrs, then spurious
	nop				# delay slot

	/*
	 * Find irq with highest priority, defined as 7(high)..0(low)
	 */

	la	a0,7
1:	bltz	t0,2f			# found pending irq
	subu	a0,1
	sll	t0,1
	b	1b
	nop				# delay slot


call_do_IRQ:
2:	move	a1,sp
	jal	tango2_dispatch
	nop				# delay slot
	j       ret_from_irq
	nop

3:	j	spurious_interrupt
	END(tango2IRQ)

/*
 * This function is used to translate the virtual address into physical one, the
 * virtual address needs to be in KUSEG or KSEG2 -- modified from except_vec0_r4000
 * refer to ../mm/tlbex-mips32.S for details.
 */
	.set	noreorder
	.set	noat
	LEAF(__em86xx_vfn2pfn)
	.set	mips3

	addu	t0, a0, zero
	lw	t1, pgd_current			# get pgd pointer
	nop
	srl	t0, t0, _PGDIR_SHIFT		# get pgd only bits

	sll	t0, t0, 2
	addu	t1, t1, t0			# add in pgd offset

	mfc0	t0, CP0_CONTEXT			# get context reg
	lw	t1, (t1)
	srl	t0, t0, 1			# get pte offset
	and	t0, t0, 0xff8
	addu	t1, t1, t0			# add in offset

	bnez	a1, 1f				# a1==odd_flag
	nop
	lw	t0, 0(t1)			# get even pte
	srl	t0, t0, 6
	b	2f
	add	v0, t0, zero

1:
	lw	t1, 4(t1)			# get odd pte
	srl	t1, t1, 6
	add	v0, t1, zero

2:
	jr	ra
	srl	v0, v0, 6
	
	END(__em86xx_vfn2pfn)
