/*****************************************
 Copyright  2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   common.h
  @brief  

  long description

  @author Emmanuel Michon
  @date   2002-11-13
*/

#ifndef __COMMON_H__
#define __COMMON_H__

#ifndef CONFIG_GNET
#define ALLOW_OS_CODE 1
#include "../rmdef/rmdef.h"

#include "../llad/include/llad.h"
#include "../llad/include/gbus.h"

#include "../gbuslib/include/gbus_mutex.h"
#include "../gbuslib/include/gbus_fifo.h"
#include "../gbuslib/include/gbus_logger.h"

#include "../emhwlib_hal/include/emhwlib_registers.h"
#include "../emhwlib/include/emhwlib_resources.h"
#include "../emhwlib_hal/include/emhwlib_lram.h"
#include "../emhwlib/include/emhwlib_event.h"


struct kc_tasklet_struct;
#if (EM86XX_MODE==EM86XX_MODEID_WITHHOST) 
#include "../llad/mum/include/mum_kk.h"
#elif (EM86XX_MODE==EM86XX_MODEID_STANDALONE)
#include "../llad/direct/include/direct_kk.h"
#endif //EM86XX_MODE

#else // CONFIG_GNET

#ifndef __RMEM86XXID_H__
// mips kernels have the integral rmem86xxid.h already. arm kernels: in gnet patch only
#include "rmem86xxid.h"
#endif

#include "emhwlib.h"
#endif

#include "macros.h"

#include "minor.h"
#include "probe.h"
#include "gnet_k.h"
#include "net.h"

#endif // __COMMON_H__
