/*****************************************
 Copyright  2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/

#include "kernelheaders.h"
#include "common.h"

// to enable or disable the debug messages of this source file, put 1 or 0 below
#if 0
#define LOCALDBG ENABLE
#else
#define LOCALDBG DISABLE
#endif

int gnetk_init(struct gnetprivate *pG,struct gbus *pgbus,struct gbus_fifo *rxfifo,struct gbus_fifo *txfifo)
{       
	PG_RMDBGLOG((LOCALDBG,"gnetk_init: begun\n"));
	
	memset(pG,0,sizeof(struct gnetprivate));

	pG->pgbus=pgbus;
	pG->rxfifo=rxfifo;
	pG->txfifo=txfifo;

	if (net_init(pG)==0) 
		register_netdev(&pG->netdev);
	else 
		return -1;

	PG_RMDBGLOG((LOCALDBG,"gnetk_init: done\n"));
	
	return 0;
}

void gnetk_cleanup(struct gnetprivate *pG)
{
        PG_RMDBGLOG((LOCALDBG,"gnetk_cleanup: begun\n"));

	if (pG->netdev.name[0]!=0) 
		unregister_netdev(&pG->netdev);
	
        PG_RMDBGLOG((LOCALDBG,"gnetk_cleanup: done\n"));
}
