/*****************************************
 Copyright  2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   kernelheaders.h
  @brief  

  long description

  @author Emmanuel Michon
  @date   2002-12-03
*/

#ifndef __KERNELHEADERS_H__
#define __KERNELHEADERS_H__

#if (defined EM86XX_MODE) && (EM86XX_MODE == EM86XX_MODEID_STANDALONE)
/*
  RMuint32 and such types are present in the kernel headers already
  protected by __RMBTYPES_H__
  hack: clean this definitely by the inclusion of rmdef in kernel.
 */
#define ALLOW_OS_CODE 1
#include "../rmdef/rmdef.h"
#endif

#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>

#include <linux/fs.h>
#include <linux/poll.h>
#include <linux/pci.h>
#include <linux/interrupt.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/slab.h>
#include <linux/delay.h>
#include <linux/init.h>
#include <linux/vmalloc.h>
#include <linux/devfs_fs_kernel.h>

#include <asm/uaccess.h>
#include <asm/system.h>
#include <asm/irq.h>
#include <asm/pgtable.h>
#include <asm/io.h>
#include <asm/bitops.h>
#include <asm/param.h>

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/ip.h>
#include <linux/ipv6.h>
#include <asm/checksum.h>

#endif // __KERNELHEADERS_H__
