#ifndef __TANGO2_USB_H__
#define __TANGO2_USB_H__

#include <linux/usb.h>
#include <asm/addrspace.h>
#include <asm/tango2/hardware.h>

#define NON_CACHED(x)                   KSEG1ADDR((u32)(x))
#define CACHED(x)                       KSEG0ADDR((u32)(x))


#define TANGO2_EHCI_BASE_ADDR           /*NON_CACHED*/(REG_BASE_host_interface + 0x1400)
#define TANGO2_OHCI_BASE_ADDR           /*NON_CACHED*/(REG_BASE_host_interface + 0x1500)
#define TANGO2_USB_CTL_STATUS_REG_BASE  /*NON_CACHED*/(REG_BASE_host_interface + 0x1700)
#define TANGO2_EHCI_IRQ                 IRQ_CONTROLLER_IRQ_BASE + LOG2_CPU_USB_EHCI_INT
#define TANGO2_OHCI_IRQ                 IRQ_CONTROLLER_IRQ_BASE + LOG2_CPU_USB_OHCI_INT

/* tango2 ehci */
#define TANGO2_EHCI_BUS_NAME            "tango2-ehci-bus"
#define TANGO2_EHCI_PRODUCT_DESC        "Tango2 Integrated USB 2.0"
#define hcd_name                        "tango2-ehci-hcd"
/* tango2 ohci */
#define ohci_hcd_name                   "tango2-ohci-hcd"
#define TANGO2_OHCI_BUS_NAME            "tango2-ohci-bus"

extern void *tango2_alloc_consistent(size_t size, dma_addr_t * dma_handle);
extern void tango2_free_consistent(size_t size, void *vaddr, dma_addr_t dma_handle);
extern struct tango2_pool *tango2_pool_create (const char *name, /*struct pci_dev *pdev,*/
                                        size_t size, size_t align, size_t allocation, int flags);
extern void tango2_pool_destroy (struct tango2_pool *pool);
extern void tango2_pool_free (struct tango2_pool *pool, void *vaddr, dma_addr_t dma);
extern void tango2_usb_init (void);
#endif

