/*****************************************
 Copyright © 2001-2003  
 Sigma Designs, Inc. All Rights Reserved
 Proprietary and Confidential
 *****************************************/
/**
  @file   tango2.h
  @brief  

  <long description>

  @author Emmanuel Michon
  @date   2004-05-10
*/

#ifndef __TANGO2_H__
#define __TANGO2_H__

#include <linux/config.h>
#include <asm/tango2/hardware.h>
#include <asm/tango2/rmem86xxid.h>

#define TANGO2_BASE_FREQUENCY	27000000 

/* Baudrate setting */
#ifdef CONFIG_QUICKTURN
#define TANGO2_BASE_BAUD 1200
#define TANGO2_CPU_FREQUENCY 250000
#elif defined(CONFIG_TANGO2_SMP863X)
#ifndef CONFIG_TANGO2_BASE_BAUD
#define TANGO2_BASE_BAUD 38400
#else
#define TANGO2_BASE_BAUD CONFIG_TANGO2_BASE_BAUD
#endif
//#define TANGO2_CPU_FREQUENCY 333000000
#else
#error "Unsupported platform"
#endif /* CONFIG_QUICKTURN */

/* Memory size used by Linux */
#ifndef CONFIG_TANGO2_MEMSIZE
#ifdef CONFIG_QUICKTURN
#define  TANGO2_SYSTEMRAM_ACTUALSIZE   (16*1024*1024)
#elif defined(CONFIG_TANGO2_SMP863X)
#define  TANGO2_SYSTEMRAM_ACTUALSIZE   (32*1024*1024)
#else
#error "Unsupported platform"
#endif /* CONFIG_QUICKTURN */
#else
#define TANGO2_SYSTEMRAM_ACTUALSIZE    CONFIG_TANGO2_MEMSIZE
#endif /* !CONFIG_TANGO2_MEMSIZE */

#define TANGO2_CTRLIRQ 0
#define TANGO2_CTRLFIQ 1
#define TANGO2_CTRLIIQ 2

#ifdef CONFIG_QUICKTURN
#define SYS_clkgen_pll        SYS_clkgen3_pll
#elif defined(CONFIG_TANGO2_SMP863X)
#if (EM86XX_REVISION <= 3)
#define SYS_clkgen_pll        SYS_clkgen3_pll
#else /* For ES4 or above */
#define SYS_clkgen_pll        SYS_clkgen3_pll
#endif
#endif

#endif // __TANGO2_H__

